/**
 * Converting data to Form Data
 * @author TMJP Engineering
 * @copyright TMJ Philippines BPO Services Inc. 2016
 */

(function() {
    'use strict';

    angular
        .module('tmjModal')
        .service('TMJFormData', TMJFormData);

    TMJFormData.$inject = [];

    /* @ngInject */
    function TMJFormData() {
        this.build = build;

        function build(data, formData, otherKey) {
            if(!data)
                return;

            var fd = formData || new FormData();
            var temp; // identifier

            for(var key in data)
            {
                // use to prevent prototypes to be included in loop (eg. obj.length)
                if(!data.hasOwnProperty(key))
                    continue;

                if(typeof data[key] == 'object') // array or object
                {
                    //recursion call itself change the data
                    fd = this.build(data[key], fd, key);
                }

                // if other key exist means multi array
                var field = (!otherKey) ? key : otherKey + '['+ key +']';
                fd.append(field, data[key]);
            }

            return fd;
        }
    }
})();
